This patch removes some linefeed characters after some hash marks.

--- original/amavisd	2006-05-08 18:23:50.000000000 +0200
+++ modified/amavisd	2006-05-08 23:03:46.000000000 +0200
@@ -112,7 +112,7 @@
 
 no warnings 'uninitialized';
 
-#
+#
 package Amavis::Boot;
 use strict;
 use re 'taint';
@@ -158,7 +158,7 @@
 
 1;
 
-#
+#
 package Amavis::Conf;
 use strict;
 use re 'taint';
@@ -1264,7 +1264,7 @@
 
 1;
 
-#
+#
 package Amavis::Lock;
 use strict;
 use re 'taint';
@@ -1293,7 +1293,7 @@
 
 1;
 
-#
+#
 package Amavis::Log;
 use strict;
 use re 'taint';
@@ -1431,7 +1431,7 @@
 
 1;
 
-#
+#
 package Amavis::Timing;
 use strict;
 use re 'taint';
@@ -1517,7 +1517,7 @@
 
 1;
 
-#
+#
 package Amavis::Util;
 use strict;
 use re 'taint';
@@ -2257,7 +2257,7 @@
 
 1;
 
-#
+#
 package Amavis::rfc2821_2822_Tools;
 use strict;
 use re 'taint';
@@ -2925,7 +2925,7 @@
 
 1;
 
-#
+#
 package Amavis::Lookup::RE;
 use strict;
 use re 'taint';
@@ -3043,7 +3043,7 @@
 
 1;
 
-#
+#
 package Amavis::Lookup::IP;
 use strict;
 use re 'taint';
@@ -3305,7 +3305,7 @@
 
 1;
 
-#
+#
 package Amavis::Lookup::Label;
 use strict;
 use re 'taint';
@@ -3317,7 +3317,7 @@
 
 1;
 
-#
+#
 package Amavis::Lookup;
 use strict;
 use re 'taint';
@@ -3572,7 +3572,7 @@
 
 1;
 
-#
+#
 package Amavis::Expand;
 use strict;
 use re 'taint';
@@ -3858,7 +3858,7 @@
 
 1;
 
-#
+#
 package Amavis::TempDir;
 
 # Handles creation and cleanup of persistent temporary directory
@@ -4086,7 +4086,7 @@
 
 1;
 
-#
+#
 package Amavis::IO::Zlib;
 
 # A simple IO::File -compatible wrapper around Compress::Zlib,
@@ -4191,7 +4191,7 @@
 
 1;
 
-#
+#
 package Amavis::In::Connection;
 
 # Keeps relevant information about how we received the message:
@@ -4224,7 +4224,7 @@
 
 1;
 
-#
+#
 package Amavis::In::Message::PerRecip;
 
 use strict;
@@ -4368,7 +4368,7 @@
 
 1;
 
-#
+#
 package Amavis::In::Message;
 # this class contains information about the message being processed
 
@@ -4523,7 +4523,7 @@
 
 1;
 
-#
+#
 package Amavis::Out::EditHeader;
 
 # Accumulates instructions on what lines need to be added to the message
@@ -4757,7 +4757,7 @@
 }
 1;
 
-#
+#
 package Amavis::Out;
 use strict;
 use re 'taint';
@@ -4819,7 +4819,7 @@
 
 1;
 
-#
+#
 package Amavis::UnmangleSender;
 use strict;
 use re 'taint';
@@ -4975,7 +4975,7 @@
 
 1;
 
-#
+#
 package Amavis::Unpackers::NewFilename;
 use strict;
 use re 'taint';
@@ -5063,7 +5063,7 @@
 
 1;
 
-#
+#
 package Amavis::Unpackers::Part;
 use strict;
 use re 'taint';
@@ -5150,7 +5150,7 @@
 
 1;
 
-#
+#
 package Amavis::Unpackers::OurFiler;
 use strict;
 use re 'taint';
@@ -5191,7 +5191,7 @@
 
 1;
 
-#
+#
 package Amavis::Unpackers::Validity;
 use strict;
 use re 'taint';
@@ -5439,7 +5439,7 @@
 
 1;
 
-#
+#
 package Amavis::Unpackers::MIME;
 use strict;
 use re 'taint';
@@ -5609,7 +5609,7 @@
 
 1;
 
-#
+#
 package Amavis::Notify;
 use strict;
 use re 'taint';
@@ -6223,7 +6223,7 @@
 
 1;
 
-#
+#
 package Amavis::Cache;
 # offer an 'IPC::Cache'-compatible simple interface
 # to a local (per-process) memory-based cache;
@@ -6292,7 +6292,7 @@
 
 1;
 
-#
+#
 package Amavis;
 require 5.005;  # need qr operator and \z in regexps
 use strict;
@@ -9445,7 +9445,7 @@
 #
 
 __DATA__
-#
+#
 package Amavis::DB::SNMP;
 use strict;
 use re 'taint';
@@ -9649,7 +9649,7 @@
 
 1;
 
-#
+#
 package Amavis::DB;
 use strict;
 use re 'taint';
@@ -9728,7 +9728,7 @@
 1;
 
 __DATA__
-#
+#
 package Amavis::Cache;
 # offer an 'IPC::Cache'-compatible interface to a BerkeleyDB-based cache.
 # Replaces methods new,get,set of the memory-based cache.
@@ -9868,7 +9868,7 @@
 1;
 
 __DATA__
-#
+#
 package Amavis::Lookup::SQLfield;
 use strict;
 use re 'taint';
@@ -9968,7 +9968,7 @@
 
 1;
 
-#
+#
 package Amavis::Lookup::SQL;
 use strict;
 use re 'taint';
@@ -10314,7 +10314,7 @@
 
 1;
 
-#
+#
 package Amavis::Lookup::LDAPattr;
 
 use strict;
@@ -10409,7 +10409,7 @@
 
 1;
 
-#
+#
 package Amavis::Lookup::LDAP;
 
 use strict;
@@ -10611,7 +10611,7 @@
 1;
 
 __DATA__
-#
+#
 package Amavis::In::AMCL;
 use strict;
 use re 'taint';
@@ -11125,7 +11125,7 @@
 1;
 
 __DATA__
-#
+#
 package Amavis::In::SMTP;
 use strict;
 use re 'taint';
@@ -11910,7 +11910,7 @@
 1;
 
 __DATA__
-#
+#
 package Amavis::In::Courier;
 use strict;
 use re 'taint';
@@ -11921,7 +11921,7 @@
 1;
 
 __DATA__
-#
+#
 package Amavis::Out::SMTP;
 use strict;
 use re 'taint';
@@ -12410,7 +12410,7 @@
 1;
 
 __DATA__
-#
+#
 package Amavis::Out::Pipe;
 use strict;
 use re 'taint';
@@ -12585,7 +12585,7 @@
 1;
 
 __DATA__
-#
+#
 package Amavis::Out::BSMTP;
 use strict;
 use re 'taint';
@@ -12759,7 +12759,7 @@
 1;
 
 __DATA__
-#
+#
 package Amavis::Out::Local;
 use strict;
 use re 'taint';
@@ -13013,7 +13013,7 @@
 1;
 
 __DATA__
-#
+#
 package Amavis::OS_Fingerprint;
 use strict;
 use re 'taint';
@@ -13502,7 +13502,7 @@
 1;
 
 __DATA__
-#
+#
 package Amavis::IO::SQL;
 # a simple IO wrapper around SQL for inserting/retrieving mail text
 # to/from a database
@@ -13824,7 +13824,7 @@
 1;
 
 __DATA__
-#
+#
 package Amavis::AV;
 use strict;
 use re 'taint';
@@ -14416,7 +14416,7 @@
 1;
 
 __DATA__
-#
+#
 package Amavis::SpamControl;
 use strict;
 use re 'taint';
@@ -14631,7 +14631,7 @@
 1;
 
 __DATA__
-#
+#
 package Amavis::SpamControl::SpamAssassin;
 use strict;
 use re 'taint';
@@ -15053,7 +15053,7 @@
 1;
 
 __DATA__
-#
+#
 package Amavis::Unpackers;
 use strict;
 use re 'taint';
@@ -16425,7 +16425,7 @@
 1;
 
 __DATA__
-#
+#
 # =============================================================================
 # This text section governs how a main per-message amavisd-new log entry is
 # formed (config variable $log_templ). An empty text will prevent a log entry,
@@ -16468,7 +16468,7 @@
 , %y ms#
 ]
 __DATA__
-#
+#
 # =============================================================================
 # This text section governs how a main per-recipient amavisd-new log entry
 # is formed (config variable $log_recip_templ). An empty text will prevent a